/*
 * Created on 2020-02-07 ( Time 09:01:54 )
 * Generated by Telosys Tools Generator ( version 3.1.2 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.salaamsolutions.projet.spasuce.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;
import java.util.List;

import javax.persistence.*;

import lombok.*;

/**
 * Persistent class for entity stored in table "entreprise"
 *
* @author Back-End developper
   *
 */

@Entity
@Table(name="entreprise" )
@Data // getters setters
@AllArgsConstructor // constructeur avec arguments
@NoArgsConstructor // constructeur sans arguments
public class Entreprise implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="nom", length=255)
    private String     nom          ;

	/*
	 * 
	 */
    @Column(name="email", length=255)
    private String     email        ;

	/*
	 * 
	 */
    @Column(name="numero_immatriculation", length=255)
    private String     numeroImmatriculation ;

	/*
	 * 
	 */
    @Column(name="numero_duns", length=255)
    private String     numeroDuns   ;

	/*
	 * 
	 */
    @Column(name="password", length=255)
    private String     password     ;

	/*
	 * 
	 */
    @Column(name="numero_fix", length=255)
    private String     numeroFix    ;

	/*
	 * 
	 */
    @Column(name="numero_fax", length=255)
    private String     numeroFax    ;

	/*
	 * 
	 */
    @Column(name="telephone", length=255)
    private String     telephone    ;

	/*
	 * 
	 */
    @Column(name="login", length=255)
    private String     login        ;

	/*
	 * 
	 */
    @Column(name="url_logo", length=255)
    private String     urlLogo      ;

	/*
	 * 
	 */
    @Column(name="extension_logo", length=255)
    private String     extensionLogo ;

	/*
	 * 
	 */
    @Column(name="description")
    private String     description  ;

	/*
	 * elle correspond à la moyenne de toute les notes obtenus
	 */
    @Column(name="note")
    private Float      note         ;

	/*
	 * 
	 */
    @Column(name="is_locked")
    private Boolean    isLocked     ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	// "villeId" (column "ville_id") is not defined by itself because used as FK in a link 
	// "typeEntrepriseId" (column "type_entreprise_id") is not defined by itself because used as FK in a link 
	// "statutJuridiqueId" (column "statut_juridique_id") is not defined by itself because used as FK in a link 
	// "classeNoteId" (column "classe_note_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="ville_id", referencedColumnName="id")
        private Ville ville;
    @ManyToOne
    @JoinColumn(name="statut_juridique_id", referencedColumnName="id")
        private StatutJuridique statutJuridique;
    @ManyToOne
    @JoinColumn(name="classe_note_id", referencedColumnName="id")
        private ClasseNote classeNote;
    @ManyToOne
    @JoinColumn(name="type_entreprise_id", referencedColumnName="id")
        private TypeEntreprise typeEntreprise;

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
